<?php

/**
 * detalle_reintegro actions.
 *
 * @package    controlComisiones
 * @subpackage detalle_reintegro
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class detalle_reintegroActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_DETA_REINTEGRO','COM_REINTEGRO', 'COM_PAGO_EGRESO', 'COM_CUENTA_V','PR_RUBRO_PRESUP_V','PROYECTOS','OBJETOS_GASTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_REINTEGRO' =>
        array(
            'id_reintegro' => 'COM_DETA_REINTEGRO'
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'id_pago_egreso' => 'COM_REINTEGRO'
        ),
        'COM_CUENTA_V' =>
        array(
            'id_cuenta' => 'COM_PAGO_EGRESO'
        ),
        'PR_RUBRO_PRESUP_V' =>
        array(
            'id_rubro' => 'COM_DETA_REINTEGRO'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_DETA_REINTEGRO'
        ),
        'OBJETOS_GASTO' =>
        array(
            'id_obj_gasto-id' => 'COM_DETA_REINTEGRO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_DETA_REINTEGRO'=>
        array(
         
            'id_deta_reintegro' => 'id_deta_reintegro',
            'id_reintegro' => 'id_reintegro',
            'id_proyecto' => 'id_proyecto',
            'id_rubro' => 'id_rubro',
            'id_obj_gasto' => 'id_obj_gasto',
            'valor_reintegro' => 'valor_reintegro'
        ),
        'COM_REINTEGRO' =>
        array(
            'id_pago_egreso' => 'id_pago_egreso',
            'id_anhos' => 'id_anhos',
            'fecha_reintegro' => 'fecha_reintegro',
            'valor_total' => 'valor_total',
            
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'id_cuenta' => 'id_cuenta',
            'no_pago' => 'no_pago',
            'fecha_pago' => 'fecha_pago',
            'valor_neto' => 'valor_neto',
        ),
        'COM_CUENTA_V' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'no_cuenta' => 'no_cuenta',
            'fecha_cuenta' => 'fecha_cuenta',
            'id_tercero' => 'id_tercero',
            'valor' => 'valor'
        ),
        'PR_RUBRO_PRESUP_V' =>
        array(
            'rubro' => 'rubro',
            'descripcion' => 'descripcion_rubro'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'OBJETOS_GASTO' =>
        array(
            'codigo' => 'codigo_ob',
            'descripcion' =>'descripcion_obj'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_DETA_REINTEGRO' =>
        array(
            'id_deta_reintegro,a' => array('!=' => array(-1)),
            'id_deta_reintegro,b' => array('=' => array('id_deta_reintegro')),
            'id_reintegro' => array('=' => array('id_reintegro')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_deta_reintegro'; //identificador de la tabla
    protected $id_names = array('id_deta_reintegro'); //llave primaria
    protected $field_names = array('id_reintegro', 'id_proyecto', 'id_rubro', 'id_obj_gasto','valor_reintegro'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_DETA_REINTEGRO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_deta_reintegro'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_reintegro = $request['id_reintegro'];
        $id_rubro = $request['id_rubro'];
        $id_proyecto = $request['id_proyecto'];
        $id_obj_gasto = $request['id_obj_gasto'];
        $valor = $request['valor_reintegro'];
        
          $sql = <<<EOD
SELECT id_pago_egreso from com_reintegro where id_reintegro = $id_reintegro
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $id_pago_egreso = $records[0]['id_pago_egreso'];
        
        
        $sql = <<<EOD
SELECT tab0.id_pago_egreso,tab0.id_proyecto,tab0.id_rubro,tab0.id_obj_gasto,(tab0.valor_cuenta-tab0.legalizado-tab0.reintegros) as saldo

from(

select tab1.id_pago_egreso, tab0.id_proyecto,tab0.id_rubro,tab0.id_obj_gasto,NVL(tab0.valor_cuenta,0) VALOR_CUENTA,NVL(tab2.valor,0) AS LEGALIZADO, NVL(tab3.valor,0)  AS REINTEGROS

from com_deta_cuenta tab0
join com_pago_egreso tab1 ON tab1.id_cuenta = tab0.id_cuenta

left join(
select tab0.id_pago_egreso,tab1.id_objeto_gasto,sum(tab0.vr_bruto + tab0.vr_iva) AS VALOR

from com_registro_gasto tab0
left join pr_elementos_gasto tab1 ON tab1.id_elementos_gasto = tab0.id_elementos_gasto
GROUP BY tab0.id_pago_egreso,tab1.id_objeto_gasto

)tab2 ON tab2.id_pago_egreso = tab1.id_pago_egreso and tab2.id_objeto_gasto = tab0.id_obj_gasto

left join(
select tab1.id_pago_egreso,tab0.id_obj_gasto,tab0.id_proyecto,tab0.id_rubro,sum(nvl(tab0.valor_reintegro,0)) AS VALOR
from com_deta_reintegro tab0
join com_reintegro tab1 ON tab1.id_reintegro = tab0.id_reintegro
where tab1.estado = 1                
group by tab1.id_pago_egreso,tab0.id_obj_gasto,tab0.id_proyecto,tab0.id_rubro
) tab3 ON tab3.id_pago_egreso = tab1.id_pago_egreso and tab3.id_proyecto = tab0.id_proyecto and tab3.id_obj_gasto = tab0.id_obj_gasto and tab3.id_rubro = tab0.id_rubro

)tab0

where tab0.id_pago_egreso = $id_pago_egreso and tab0.id_proyecto = $id_proyecto and tab0.id_rubro = $id_rubro and tab0.id_obj_gasto = $id_obj_gasto


EOD;

        $records = CN_TABLE::executeSQL($sql);

        $saldo = $records[0]['saldo'];
        
        if($saldo<$valor){
            
            $errors['mensaje'] = "No queda saldo para registrar este reintegro. Favor verificar.";
            $errors['servicio'] = "detalle_reintegro";
            
        }
        
        
        
        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        
        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
}
